// rev 10/08/2023 simplifications car  1 seul jeu de car speciaux
// rev 08-08-2023  deplac tables caracteres speciaux dans fichier annexe LCD_chars_Speciaux_2024-08.h
// rev 13-07-2023
// modif Fleche H et B en video onverse
// modif 8 cars speciaux A,B,C,D,E,F,G,H  video inverse
// rev 01/05/2023
// deplac caractere special  degre C de la position 0  la position 7
// le 1er car special etant vide 
// rev 18_04-2023
//------------------------
 //PCF8574 pour LCD 2x16 avec A0,A1,A2  au niveau logique 0
//#define LCD_ADDR 0x20   //PCF8574  externe LCD 4x20 Blanc carte chaudiere
 #define LCD_ADDR 0x27  //PCF8574 inclus sur gros LCD 4x20 Bleu Paul sur Prototype Breaboard
 // Hardware :
 // PCF8574 I2C LCD Port Definition
 // P7,P6,P5,P4 = 4 bits Data  -> LCD D7..D4
 // P0=RS ,  P1=RW  not used car RW=0V , P2=Enb  P3=Backlight (BL) not used
 #define LCD_BL 0x08      // P3
 #define LCD_EN 0x04      // P2
 #define LCD_RW 0x02      // P1
 #define LCD_RS 0x01      // P0

#define LCD_CLEAR 0x01
#define LCD_HOME  0x02
#define Display_ON 0x0C
#define Display_OFF 0x08
    
 // LCD Command
#define LCD_LINE1 0x80      // 0x00 + bit D7=1
#define LCD_LINE2 0xC0      // 0x40 + bit D7=
#define LCD_LINE3 0x94 // 0x14 + bit D7=1
#define LCD_LINE4 0xD4 // 0x54 + bit D7=1

//volatile int NbCarPL =20 ; //16 pour LCD2x16;
volatile int NbCarPL=20;  //20;
const unsigned char LINE[5] ={0x00,0x80,0xC0,0x94,0xD4};
const char Efface[21]="                    ";

#include "LCD_chars_Speciaux_2025-02.h"



 //  **************************************************
//   LCD 
volatile unsigned char Addr;
//volatile unsigned char Adresse_7bits;
unsigned char I2_Adresses_Devices[8];
//extern unsigned char tmp[] ;
extern char tmp[] ;
int Etat;
int Step=0;

extern void CPrint (const unsigned char *T1);
extern void PrintChar( unsigned char txData);
extern void CRLF1(void);
extern void strConstRamCpy(unsigned char  *dest, const  unsigned char *source);

extern void I2C_PCF8574_Write(unsigned char  Addr , unsigned char value);
extern void Decompile_byte(unsigned char un);


void LCD_init(void);
void LCD_putcmd(unsigned char d,unsigned char cmdtype);
void LCD_Chr_At(int Ligne,int col,unsigned char c1);
void LCD_putch(unsigned char d);
void LCD_puts(unsigned char *s);
void LCD_putsRom(const unsigned char *s);
void LCD_Write_CText(const unsigned char *txt) ;
void Erase_Line(int L);
void LCD_At(unsigned char Ligne,unsigned char  col);
void LCD_Write_Text_At(unsigned char Ligne,unsigned char col, unsigned char * t1);
void LCD_Write_CText_At(unsigned char Ligne,unsigned char col,const unsigned char * t1);
void LCD_Cmd(unsigned char d);
void LCD_Load_Custom_Chars(int bavard);  //  10-08-2023 1 seul jeu de car
void LCD_Data(unsigned char d);

